// Test GameState

#ifndef MUISCSTATE_H
#define MUISCSTATE_H

#include "../ToolKit/Singleton.h"
#include "../StateModule/GameState.h"

#include "../Timer/FpsCounter.h"

// Forward declare classes
namespace GfxModule
{
    class FontWrapper;
}

class MusicState : public GameStateModule::GameState, public Singleton<MusicState>
{
private:
    GfxModule::FontWrapper * _CourierNewFont;
    TimerModule::FpsCounter _FpsCounter;

public:
    MusicState(void) :
        _CourierNewFont(0)
    {
        // Intentionally empty
    }

    ~MusicState(void)
    {
        // Intentionally empty
    }

    //! Pure virtual. Initialise the state when the state is pushed on top the stack
    void PushInitialise(
        GfxModule::GfxModuleWrapper* AGfxModule,
        SoundModule::SoundModuleWrapper* ASoundModule
    );

    //! Pure virtual. Cleanup up the state when it is pushed then further into the stack
    void PushCleanup(
        GfxModule::GfxModuleWrapper* AGfxModule,
        SoundModule::SoundModuleWrapper* ASoundModule
    );

    //! Pure virtual. When the state is popped up to the top of the stack
    void PopInitialise(
        GfxModule::GfxModuleWrapper* AGfxModule,
        SoundModule::SoundModuleWrapper* ASoundModule
    );

    //! Pure virtual. When the state is popped off the stack
    void PopCleanup(
        GfxModule::GfxModuleWrapper* AGfxModule,
        SoundModule::SoundModuleWrapper* ASoundModule
    );
    //! Pure virtual. Gets called once per frame when it is on top of the stack
    void Update(
        GfxModule::GfxModuleWrapper* AGfxModule,
        SoundModule::SoundModuleWrapper* ASoundModule,
        InputModule::Input* AInputModule,
        GameStateModule::GameStateManager* AGameStateManager
    );
};

#endif // MUISCSTATE_H
